var imgListArray = new Array();
var imgList = new String();
var index = -1;
var button0hold = 0;
var button2hold = 0;
var indexXOffset = 0;
var indexYOffset = 0;
var referrer = Components.classes["@mozilla.org/network/standard-url;1"]
                          .getService(Components.interfaces.nsIURI);

window.addEventListener("mouseUp", bimouseup, true);
window.addEventListener("mousedown", bimousedown, true);
window.addEventListener("click", biclick, true);
window.addEventListener("blur", createImgList,true);
window.addEventListener("load", restoreOffset,true);
window.addEventListener("load", initMenu,true);

function restoreOffset() {
	
	if(imgListArray.length > 1 && index == imgListArray.length - 1) {
		content.scrollTo(indexXOffset,indexYOffset);
	}

}

function createImgList() {
	
	
	
	if(imgList.indexOf(content.document.URL + "\n") == -1) {
		imgList = "";
		index = -1;
		
		var jpgIndex = -1;
		var gifIndex = -1;
		var pngIndex = -1;
		var jpegIndex = -1;
		var bmpIndex = -1;
		
		for(var i = 0; i < content.document.links.length; i++) {
			
			jpgIndex = content.document.links[i].toString()
				   	.toLowerCase().lastIndexOf(".jpg");
			gifIndex = content.document.links[i].toString()
					.toLowerCase().lastIndexOf(".gif");
			pngIndex = content.document.links[i].toString()
					.toLowerCase().lastIndexOf(".png");
			jpegIndex = content.document.links[i].toString()
					.toLowerCase().lastIndexOf(".jpeg");
			bmpIndex = content.document.links[i].toString()
					.toLowerCase().lastIndexOf(".bmp");
			
			if((       jpgIndex > -1 && content.document.links[i]
						.toString().charAt(jpgIndex + 4)
						.toString().search(/[\w-\/]/) 
						== -1
				|| gifIndex > -1 && content.document.links[i]
						.toString().charAt(gifIndex + 4)
						.toString().search(/[\w-\/]/) 
						== -1
				|| pngIndex > -1 && content.document.links[i]
						.toString().charAt(pngIndex + 4)
						.toString().search(/[\w-\/]/)
						== -1
				|| bmpIndex > -1 && content.document.links[i]
						.toString().charAt(bmpIndex + 4)
						.toString().search(/[\w-\/]/) 
						== -1
				|| jpegIndex > -1 && content.document.links[i]
						.toString().charAt(jpegIndex+5)
						.toString().search(/[\w-\/]/) 
						== -1)
				&& imgList.indexOf(content.document.links[i]
				   .toString()+ "\n") == -1) {
				
				    imgList+=(content.document.links[i] + "\n");
		}
	}
	
	imgListArray = imgList.split("\n");
	imgListArray[imgListArray.length - 1] = content.document.URL;
	imgList += content.document.URL;
	
	indexXOffset = content.pageXOffset;
	indexYOffset = content.pageYOffset;
	
	referrer.spec = content.document.URL;
	
	if(imgListArray.length > 1)
		document.getElementById("browseimages-button").setAttribute(
		    "src", "chrome://browseimages/content/browseimages-" +
		    "available-statusbar-icon.gif");
		
	else
		document.getElementById("browseimages-button").setAttribute(
	 	    "src", "chrome://browseimages/content/browseimages-not-" +
		    "available-statusbar-icon.gif");
		
    }
	
	
}

function nextImg() {
    
	button2hold = 0;

	gotoinit();
	
	if(index == imgListArray.length -1) {
            index = -1;
	}

	if(imgListArray.length > 1) {
		referrer.spec = imgListArray[imgListArray.length - 1];
		loadURI(imgListArray[++index], referrer, null);
	}
}

function prevImg() {
   
	button0hold = 0;
	
	gotoinit();
	
    if(imgListArray.length > 1) {
	if(index <= 0) {
	    index += imgListArray.length;
	}
 
	referrer.spec = imgListArray[imgListArray.length - 1];
	loadURI(imgListArray[--index], referrer, null);
    }
}


function gotoinit() {
	
	createImgList();
	correctIndex();
}


function correctIndex() {
	if(imgListArray[index] != content.document.URL) {
		index = 0;
		
		while(imgListArray[index] != content.document.URL) {
			index++;
		}
	}
}


function biclick(e) {
	
    if(e.altKey & e.shiftKey ||
	   (imgList.indexOf(content.document.URL + "\n") > -1 
		&& (e.altKey | e.shiftKey))) {
		
        	if(e.button == 0) {
		    nextImg();
		} else if(e.button == 2) {
		    prevImg();
		}
    }
	
    if(e.button == 0) {
	button0hold = 0;
    } else if(e.button == 2) {
	button2hold = 0;
    }
}

function bimousedown(e) {
    
    if(e.button == 0) {
        button0hold = 1;
    } else if(e.button == 2) {
	button2hold = 1;
    }
    
    if(button0hold == 1 & e.button == 2) {
        nextImg();		
    } else if(button2hold == 1 & e.button == 0) {
	prevImg();		
    }
}

function bimouseup(e) {
    
    if(e.button == 0) {
        button0hold = 0;
    } else if(e.button == 2) {
	button2hold = 0;
    }
}

function initMenu() {
	createImgList();
}

function buildbrowseimagesmenu(menu) {
    createImgList();
	
    while(menu.hasChildNodes()) {
	menu.removeChild(menu.lastChild);
    }
	
    if(imgListArray.length > 1) {
	for(var i = 0; i<imgListArray.length; i++) {
	    
	    var menuitem = document.createElement("menuitem");
	    var uriParts = imgListArray[i].split("/");
	    var label = uriParts[uriParts.length - 1] + " (" + 
	    		imgListArray[i]+")";  
	    
	    menuitem.setAttribute("label", label);
	    menuitem.setAttribute("value", imgListArray[i]);
	    menuitem.setAttribute("tooltiptext", imgListArray[i]);
	    menuitem.setAttribute("oncommand", "gotoImage(this);");
	    
	    menu.appendChild(menuitem);
	}
    } else {
	var menuitem = document.createElement("menuitem");
	menuitem.setAttribute("label", "No Image Links on this Page found");
	menu.appendChild(menuitem);
	
    }

    updateMenu(menu);
   
}

function gotoImage(menuitem) {
	
	referrer.spec = imgListArray[imgListArray.length - 1];
	loadURI(menuitem.getAttribute("value"), referrer, null);
	
}

function updateMenu(menu) {
	
	
	
	var menuitem = menu.getElementsByTagName("menuitem");
	
	var i = 0;
	
	while(i < menuitem.length && menuitem[i].getAttribute("value") 
	!= content.document.URL) {
	
		i++;
	}
	
	if(i < menuitem.length) {
		menuitem[i].setAttribute("label", "\u203A\u203A " + 
			menuitem[i].getAttribute("label"));
	}
	
}
